import numpy as np
import matplotlib
import matplotlib.pyplot as plt
import seaborn as sns

lin_error_rate = np.array([[0.001543,   0.002315,   0.007427,   0.003794,   0.000000,   0.012924,   0.000386,   0.004437,   0.006366,   0.000289],
                        [0.000054,   0.004027,   0.000900,   0.004394,   0.006559,   0.000043,   0.005739,   0.002894,   0.004139,   0.000096],
                        [0.008222,   0.010995,   0.003890,   0.003772,   0.004823,   0.003472,   0.001768,   0.002698,   0.008450,   0.002315],
                        [0.006987,   0.008627,   0.007523,   0.000000,   0.000322,   0.007716,   0.005980,   0.009291,   0.004630,   0.003537],
                        [0.020843,   0.023200,   0.015060,   0.007671,   0.007039,   0.000965,   0.005639,   0.004321,   0.006979,   0.012950],
                        [0.012356,   0.005150,   0.011053,   0.006954,   0.006936,   0.003618,   0.010237,   0.010632,   0.003501,   0.002511],
                        [0.016876,   0.006877,   0.008192,   0.006840,   0.011444,   0.009820,   0.006674,   0.008904,   0.007599,   0.010059],
                        [0.010164,   0.001924,   0.010138,   0.012664,   0.006185,   0.008691,   0.007851,   0.008274,   0.015066,   0.009938]])

rand_error_rate = np.array([[0.001736,   0.010738,   0.008359,   0.004662,   0.001543,   0.013503,   0.000386,   0.003874,   0.008295,   0.000289],
                        [0.000697,   0.003930,   0.002347,   0.002143,   0.006559,   0.001457,   0.005048,   0.003086,   0.003724,   0.000096],
                        [0.008705,   0.013996,   0.015231,   0.004994,   0.004823,   0.003472,   0.001768,   0.002698,   0.008375,   0.002315],
                        [0.010867,   0.010717,   0.008102,   0.000442,   0.001104,   0.009913,   0.007523,   0.008916,   0.011735,   0.006462],
                        [0.022158,   0.022055,   0.015060,   0.008057,   0.007219,   0.008886,   0.005845,   0.004803,   0.006413,   0.009137],
                        [0.011143,   0.003509,   0.013041,   0.004328,   0.008643,   0.004773,   0.010237,   0.010632,   0.004384,   0.005109],
                        [0.017085,   0.008120,   0.009638,   0.007289,   0.011837,   0.010579,   0.008740,   0.009102,   0.008491,   0.010267],
                        [0.011358,   0.004699,   0.012581,   0.014878,   0.006120,   0.009854,   0.008633,   0.008820,   0.016278,   0.011015]])

lin_time = np.array([[4.778094,   4.456182,   6.894535,   6.784226,   5.882085,   3.338271,   6.994481,   6.128729,   8.487859,   4.623986],
                    [24.797890,   29.259095,   10.884242,   19.860566,   20.971964,   13.974711,   26.828163,   15.831599,   33.170288,   11.462545],
                    [40.708975,   37.964430,   40.255426,   39.834976,   32.543777,   79.246635,   63.406060,   66.769362,   79.110744,   32.354675],
                    [118.224755,   113.353834,   64.687943,   127.596291,   106.717580,   112.106618,   70.440514,   122.830564,   111.675406,   99.468901],
                    [55.906181,   39.010482,   58.065534,   65.531285,   85.919886,   67.523512,   51.239680,   52.121218,   63.308329,   59.707372],
                    [96.022608,   149.718373,   83.109865,   128.960682,   141.044148,   112.708259,   130.042113,   81.842596,   57.893172,   102.439925],
                    [313.540317,   297.274829,   260.438979,   284.025963,   264.113729,   324.973646,   284.033690,   243.883096,   174.419244,   304.650383],
                    [692.077149,   464.415706,   638.016777,   583.917774,   516.653677,   518.679783,   536.714776,   480.590350,   562.002187,   427.868665]])

rand_time = np.array([[0.507456,   0.540617,   0.796218,   0.635458,   0.563652,   0.510737,   0.748387,   0.410240,   0.813458,   0.506050],
                    [0.533030,   0.591048,   0.332029,   0.443835,   0.542500,   0.314421,   1.144963,   0.404564,   0.553833,   0.330668],
                    [1.197669,   1.383202,   0.958994,   0.558122,   1.314136,   1.023699,   0.977540,   1.105160,   1.193539,   0.948940],
                    [2.242207,   3.201105,   2.033165,   1.588787,   2.852011,   3.502273,   2.309301,   3.796409,   2.801763,   1.654093],
                    [1.611258,   1.257719,   1.809134,   1.483876,   1.489441,   1.302414,   1.294144,   1.450707,   1.217396,   1.573476],
                    [2.277702,   3.415636,   2.464246,   3.087164,   3.007455,   2.825260,   2.739222,   2.364106,   2.020824,   2.851512],
                    [7.143442,   6.092177,   6.063795,   6.186204,   7.035191,   5.944968,   4.356444,   4.434492,   4.998872,   6.725423],
                    [13.200855,   10.273614,   12.361785,   12.961024,   13.517751,   10.708602,   10.928107,   14.245742,   11.811005,   9.500433]])

case_num = rand_time.shape[0]
repeat_num = rand_time.shape[1]

lin_case_id = np.repeat(np.arange(case_num).reshape(case_num,-1), repeat_num, axis=1)
rand_case_id = np.repeat(np.arange(case_num).reshape(case_num,-1), repeat_num, axis=1)

lin_case_group = np.zeros(rand_error_rate.shape, dtype=int)
rand_case_group = np.ones(rand_error_rate.shape, dtype=int) * 1

x_data = np.hstack((lin_case_id.reshape(-1), rand_case_id.reshape(-1)))
hue_data = np.hstack((lin_case_group.reshape(-1), rand_case_group.reshape(-1)))
y_error = np.hstack((lin_error_rate.reshape(-1), rand_error_rate.reshape(-1)))
y_time = np.hstack((lin_time.reshape(-1), rand_time.reshape(-1)))


hue_data_text = []
for i in range(len(hue_data)):
    if hue_data[i] == 0:
        hue_data_text.append('Entire')
    elif hue_data[i] == 1:
        hue_data_text.append('Random')
    elif hue_data[i] == 2:
        hue_data_text.append('Entire-N')
    elif hue_data[i] == 3:
        hue_data_text.append('Random-N')

# Plot of the function
font = {'size'   : 16}
matplotlib.rc('font', **font)

outlier_thres = 4.0

# Learner: error
# y_plot_lim = [0.0, 0.055]
fig = plt.figure(figsize=[6,4])
ax = fig.add_subplot(111)
sns.boxplot(x = x_data, y = y_error, hue = hue_data_text, whis=outlier_thres)
# ax.set_ylim(y_plot_lim)
plt.xlabel('Case')
plt.ylabel('Error rate')
fig.savefig('./temp/bo_error_box.png', bbox_inches='tight', dpi=400)

# Learner: time
y_data = np.hstack((lin_time.reshape(-1), rand_time.reshape(-1)))
fig = plt.figure(figsize=[6,4])
ax = fig.add_subplot(111)
sns.boxplot(x = x_data, y = y_time, hue = hue_data_text, whis=outlier_thres)
ax.set_yscale('log')
plt.xlabel('Case')
plt.ylabel('Training time (sec)')
fig.savefig('./temp/bo_training_time.png', bbox_inches='tight', dpi=400)

# https://docs.scipy.org/doc/scipy/reference/generated/scipy.stats.ttest_ind.html
